/*
 * MOTORES.cpp
 *
 *  Created on: 21/10/2010
 *      Author: mindurain
 */


#include "MOTORES.h"
#include <avr/interrupt.h>
#include "Arduino/HardwareSerial.h"
#include "Arduino/wiring_private.h"

#define BIT_SENTIDO_GIRO 0x80
#define SIN_SIGNO	0x7F
#define PUERTO_3	0x08

void motors(motores* p_motores, rx* p_rx)
{
	switch(p_motores->estado_motores)
	{
		case ESTADO_MOTORES_REPOSO:
		{
			if (p_rx->estado == ESTADO_RX_VALORES_MOTORES)
			{
				p_motores->vel_motor_1 = p_rx->motores[1];
				p_motores->vel_motor_2 = p_rx->motores[2];
				p_motores->vel_motor_3 = p_rx->motores[3]& SIN_SIGNO;
				p_motores->sentido_giro_motor_3 = (p_rx->motores[3]& BIT_SENTIDO_GIRO)>>7;
				p_rx->estado = ESTADO_RX_REPOSO;
				p_motores->estado_motores = ESTADO_MOTORES_CAMBIANDO_M1;
			}
		}
		break;

		case ESTADO_MOTORES_CAMBIANDO_M1: //motor hlice de un sentido posicin ms baja
		{
			OCR2A = p_motores->vel_motor_1;
			if (TCNT2>OCR2A)
				TCNT2=0xFF;
			p_motores->estado_motores = ESTADO_MOTORES_CAMBIANDO_M2;
		}
		break;

		case ESTADO_MOTORES_CAMBIANDO_M2: //motor hlice de un sentido posicin ms alta
		{
			OCR2B = p_motores->vel_motor_2;
			if (TCNT2>OCR2A)
				TCNT2=0xFF;
			p_motores->estado_motores = ESTADO_MOTORES_CAMBIANDO_M3;
		}
		break;

		case ESTADO_MOTORES_CAMBIANDO_M3: //motor hlice de dos sentidos
		{
			if (p_motores->sentido_giro_motor_3 == 1)
			{
				OCR0A = (0x80 - p_motores->vel_motor_3)<<1;
				if (TCNT0>OCR0A)
					TCNT0=0xFF;
				sbi(PORTB, DDB5);
			}else{
				OCR0A = p_motores->vel_motor_3<<1;
				if (TCNT0>OCR0A)
					TCNT0=0xFF;
				cbi(PORTB, DDB5);
			}
			p_motores->estado_motores = ESTADO_MOTORES_REPOSO;
		}
		break;
	}
}
