/*
 * TX.cpp
 *
 *  Created on: 07/10/2010
 *      Author: mindurain
 */

#include "TX.h"

void crear_paquete(int size_informacion, char cabecera_protocolo, char* informacion);
void enviar(char* datos, int longitud);

char muestreo[25];
char datos[40];

#define	BYTE_INICIO_DATOS	0
#define SIZE_START	1
#define SIZE_INFORMACION	20
#define SIZE_CRC	1
#define	CABECERA_PROTOCOLO	'E'
//#define SUM_CTE	0




void tx(int* p_estado_tx, i2c* p_i2c, analog* p_analog)
{
	switch(*p_estado_tx)
	{
		case ESTADO_TX_REPOSO:
		{
			if (	(p_i2c->estado==ESTADO_I2C_MUESTREO_TERMINADO)&&
					(p_analog->estado==ESTADO_ANALOG_MUESTREO_TERMINADO) //meter el timer para cambio de estado
				)
			{
				*p_estado_tx=ESTADO_TX_CREANDO_PAQUETE;
				p_i2c->estado=ESTADO_I2C_REPOSO;
				p_analog->estado=ESTADO_ANALOG_REPOSO;
			}
		}
		break;

		case ESTADO_TX_CREANDO_PAQUETE:
		{
			crear_array_muestreo(muestreo, p_analog, p_i2c);
			crear_paquete(SIZE_INFORMACION,CABECERA_PROTOCOLO, muestreo);
			*p_estado_tx=ESTADO_TX_ENVIANDO_SERIE;
		}
		break;

		case ESTADO_TX_ENVIANDO_SERIE:
		{
			enviar(datos,SIZE_START+SIZE_INFORMACION+SIZE_CRC);  // Enviar datos por la uart
			*p_estado_tx=ESTADO_TX_REPOSO;  // cambiar a estado reposo
		}
		break;
	}
}




void crear_paquete(int size_informacion, char cabecera_protocolo, char* informacion)
{
	unsigned char sum_datos=0;
	unsigned char checksum;
	int i;

	//paquete[BYTE_LONG_PAQUETE]=size_informacion + SIZE_CABECERA+SIZE_START;
	datos[BYTE_INICIO_DATOS] = cabecera_protocolo;
	//sum_datos = cabecera_protocolo;
	for (i=0;i<size_informacion;i++)
	{
		datos[BYTE_INICIO_DATOS+i+SIZE_START]=informacion[i];
		sum_datos = sum_datos + informacion[i];
	}
	//sum_datos = SUM_CTE + sum_datos;
	checksum = 0xFF - sum_datos;
	datos[BYTE_INICIO_DATOS+i+SIZE_START]=checksum;
}


void enviar(char* datos, int longitud)
{
	int i;
	for(i=0;i<longitud;i++)
	{
		Serial.write(datos[i]);
	}
}

void crear_array_muestreo(char* muestreo, analog* p_analog, i2c* p_i2c)
{
	muestreo[0]=((p_analog->x)&(0xFF00))>>8;
	muestreo[1]=(p_analog->x)&(0x00FF);
	muestreo[2]=((p_analog->y)&(0xFF00))>>8;
	muestreo[3]=(p_analog->y)&(0x00FF);
	muestreo[4]=((p_analog->z)&(0xFF00))>>8;
	muestreo[5]=(p_analog->z)&(0x00FF);
	muestreo[6]=((p_i2c->x_accel)&(0xFF00))>>8;
	muestreo[7]=(p_i2c->x_accel)&(0x00FF);
	muestreo[8]=((p_i2c->y_accel)&(0xFF00))>>8;
	muestreo[9]=(p_i2c->y_accel)&(0x00FF);
	muestreo[10]=((p_i2c->z_accel)&(0xFF00))>>8;
	muestreo[11]=(p_i2c->z_accel)&(0x00FF);
	muestreo[12]=((p_i2c->x_magneto)&(0xFF00))>>8;
	muestreo[13]=(p_i2c->x_magneto)&(0x00FF);
	muestreo[14]=((p_i2c->y_magneto)&(0xFF00))>>8;
	muestreo[15]=(p_i2c->y_magneto)&(0x00FF);
	muestreo[16]=((p_i2c->z_magneto)&(0xFF00))>>8;
	muestreo[17]=(p_i2c->z_magneto)&(0x00FF);
	muestreo[18]=((p_analog->prox)&(0xFF00))>>8;
	muestreo[19]=(p_analog->prox)&(0x00FF);
}
